//***********************************************************
//
//  section : NXV4 package
//
//  code    : test FxL package
//
//  author  : M. Dima
//            Inst. for Nuclear Phys. & Engr.
//
//  date    : NXV4            / Tue May 4 15:17:54 CEST 2017
//
//***********************************************************
//
#include <cmath>
#include <string>
#include <sstream>
#include <stdio.h>
#include <iostream>

#include "fxl.hh"

using namespace std                                         ;

using namespace fxl4                                        ;

//===========================================================

void fread(double*   rr,
           double*   cc,
             char* file,
              int     N )
{

 double* z  = new double[N]                                 ;

 FILE* filex                                                ;
 char  stx[5000]                                            ;
 float tx, x                                                ;
 filex = fopen (file, "r")                                  ;
 if (filex == NULL) {perror ("Error opening file")          ;}
 for (int i=1; i<N+1; i++) {
   fgets (stx, 5000 , filex)                                ;
   const std::string& s = stx                               ;
   std::istringstream sty(s)                                ;
   if ( !((sty >> std::dec >> tx).fail()) ) {               ;}
   if ( !((sty >> std::dec >>  x).fail()) ) {z[i-1] = x     ;}
 }

 long double ave = 0                                        ;
 for (int ii=0; ii<N; ii++) {
   ave += z[ii]                                             ;}
 ave = ave / N                                              ;

 for (int ii=0; ii<N; ii++) z[ii] = z[ii] - ave             ;

 for (int ii=0; ii<N; ii++) {rr[ii]   = z[ii] ; cc[ii]   = 0;}

 delete[] z                                                 ;

 }

//===========================================================

int main()
{

 int N = 8192;

 double* rV = new double[N]                                 ;
 double* cV = new double[N]                                 ;
 double* rW = new double[4096]                                 ;
 double* cW = new double[4096]                                 ;

 fread(rV,cV,"data.txt",N)                                    ;

for(int i=0;i<N;i++){
rV[i] = cos(2*3.141592653*i/25000.0*50);
cV[i] = 0*sin(2*3.141592653*i/25000.0*50);
}

 cout <<  endl                                              ;



 fxl<double> V(rV,cV,N, 12, "F0 raw", 0.004, 800.0, 0.12, 0.54)  ;
 for (int i=0; i<V.N; i++) {
   rW[i] = V.ddr[i] ; cW[i] = -V.ddc[i]                          ;}
 fxl<double> L(rW,cW,N, 12, "F0 raw", 0.004, 800.0, 0.12, 0.54)  ;


 for (int i=0; i<L.N; i++) {
   cout << "VVVV " <<  i  << " " << 
                      L.ddr[i] <<
   endl                                                     ;}

 delete[] rV ; delete[] cV                                  ;


}

